unit hihiMake;

interface

uses Windows, KOL, Share, Debug;

type
  PCGrec = ^TCGrec;
  TCGrec = record
    MainForm: string;
    Vars, Units, IBody, Dead: PStrList;
  end;

type
  THiHiMake = class  // --...
  private
    P: PCGrec;
    FFileName: string;
    Arr: PArray;
    Current: PStrList;
    function _Get(var Item, Val: TData): boolean;
    function _Count: integer;
  public
    _event_onGenerate: THI_Event;
    _event_onEndBuild: THI_Event;
    
    procedure Generate(CGrec: PCGrec; FileName: PChar);
    procedure EndBuild(FileName: PChar);

    procedure _var_FileName(var _Data: TData; Index: word);
    procedure _var_Component(var _Data: TData; Index: word);
    procedure _var_Units(var _Data: TData; Index: word);
    procedure _var_Vars(var _Data: TData; Index: word);
    procedure _var_ICode(var _Data: TData; Index: word);
    procedure _var_FCode(var _Data: TData; Index: word);
  end;
  
implementation

procedure THiHiMake.Generate;
begin
  EventOn;
  FFileName := FileName;
  P := CGrec;
  _hi_onEvent(_event_onGenerate, FFileName);
  EventOff;
end;

procedure THiHiMake.EndBuild;
begin
  EventOn;
  FFileName := FileName;
  _hi_onEvent(_event_onEndBuild, FFileName);
  EventOff;
end;

function THiHiMake._Get;
var
  idx: integer;
begin
   idx := ToIntIndex(Item);
   if (idx >= 0) and (idx < Current.Count)then
     begin
        Result := true;
        dtString(Val, Current.Items[idx]);
     end
   else Result := false;
end;

function THiHiMake._Count;
begin
   Result := Current.Count;
end;

procedure THiHiMake._var_FileName;
begin
  dtString(_Data, FFileName);
end;

procedure THiHiMake._var_Component;
begin
  dtString(_Data, P.MainForm);
end;

procedure THiHiMake._var_Units;
begin
  Current := P.Units;
  if Arr = nil then
    Arr := CreateArray(nil, _Get, _Count, nil);
  dtArray(_Data, Arr);
end;

procedure THiHiMake._var_Vars;
begin
  Current := P.Vars;
  if Arr = nil then
    Arr := CreateArray(nil, _Get, _Count, nil);
  dtArray(_Data, Arr);
end;

procedure THiHiMake._var_ICode;
begin
  Current := P.IBody;
  if Arr = nil then
    Arr := CreateArray(nil, _Get, _Count, nil);
  dtArray(_Data, Arr);
end;

procedure THiHiMake._var_FCode;
begin
  Current := P.Dead;
  if Arr = nil then
    Arr := CreateArray(nil, _Get, _Count, nil);
  dtArray(_Data, Arr);
end;

end.
